---
title: XRInputSource.profiles
slug: Web/API/XRInputSource/profiles
tags:
  - API
  - AR
  - Configuration
  - Input
  - Property
  - Read-only
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRInputSource
  - augmented
  - profile
---
<p>{{APIRef("WebXR")}}{{securecontext_header}}</p>

<p><span class="seoSummary">The read-only {{domxref("XRInputSource")}} property <code><strong>profiles</strong></code> returns an array of strings, each describing a configuration profile for the input source.</span> The profile strings are listed in order of specificity, with the most specific profile listed first.</p>

<div class="notecard note">
<p><strong>Note:</strong> The <code>profiles</code> list is always empty when the WebXR session is in inline mode.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">let <em>profileList</em> = <em>xrInputSource</em>.profiles;</pre>

<h3 id="Value">Value</h3>

<p>An array of {{domxref("DOMString")}} objects, each describing one configuration profile for the input device represented by the <code>XRInputSource</code> object. Each input profile specifies the preferred visual representation and behavior of the input source.</p>

<h2 id="Usage_notes">Usage notes</h2>

<h3 id="Input_profile_names">Input profile names</h3>

<p>An input profile name is a string describing a visual representation and behavior the input source may be configured to use. Each string:</p>

<ul>
 <li>Has no spaces; instead, words are separated by hyphen ("-") characters</li>
 <li>If the platform makes it available, the USB vendor and product ID may be provided but cannot be relied upon</li>
 <li>Does not uniquely identify a specific device; rather, it identifies a configuration that the product is capable of using</li>
 <li>Does not provide information about handedness of the device, if applicable</li>
</ul>

<p>The <a href="https://github.com/immersive-web/webxr-input-profiles/tree/master/packages/registry">WebXR Input Profiles Registry</a> is used by device developers and browser developers to attempt to ensure that a given device will report the same profile strings regardless of which browser or other {{Glossary("user agent")}} you use.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrinputsource-profiles','XRInputSource.profiles')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.XRInputSource.profiles")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a></li>
 <li><a href="/en-US/docs/Web/WebXR%20Device%20API/Gamepads">Using gamepads in WebXR applications</a></li>
</ul>
